%global debug_package %{nil}

Name:         uboot-rpi
License:      GPLv2
Version:      2021.04
Release:      1.0.3%{?dist}
Summary:      u-boot for Raspberry Pi 3 & 4
Group:        System Environment/Kernel
Source0:      u-boot-%{version}.tar.bz2
## See SOURCE file for uboot repo and version

#Patches
Patch0005:    0005-Add-efidebug-command.patch
Patch0006:    0006-Change-refs-from-bootaa64-to-grubaa64.patch
Patch0020:    0020-Raspberry-Pi-UEFI-Runtime-regions-are-not-aligned-to.patch
Patch0203:    0203-rpi-Use-firmware-provided-device-tr.patch
Patch0212:    0212-smbios-Fix-table-when-no-string-is-.patch
Patch0213:    0213-configs-rpi-Enable-SMBIOS-sysinfo-d.patch



BuildRequires: dtc
BuildRequires: bison
BuildRequires: flex

%if 0%{?rhel} < 8
BuildRequires: devtoolset-6-gcc
BuildRequires: bc
%define with_devtoolset 1
%endif

%description
u-boot for Raspberry Pi 3 & 4

%prep
%setup -q -n u-boot-%{version}
%patch0006 -p1
%patch0020 -p1
%patch0203 -p1
%patch0212 -p1
%patch0213 -p1
%patch0005 -p1



%build

%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpiarm64 rpi_arm64_defconfig
%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpiarm64 %{?_smp_mflags}
#%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpi4 rpi_4_defconfig
#%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpi4 %{?_smp_mflags}
#%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpi3 rpi_3_defconfig
#%{?with_devtoolset: scl enable devtoolset-6 --} make O=rpi3 %{?_smp_mflags}

%install
mkdir -p %{buildroot}/boot/efi
cp -v  rpiarm64/u-boot.bin %{buildroot}/boot/efi/u-boot.bin
#cp -v  rpi3/u-boot.bin %{buildroot}/boot/efi/kernel8-pi3.img
#cp -v  rpi4/u-boot.bin %{buildroot}/boot/efi/kernel8-pi4.img

%files
/boot/efi/u-boot.bin
#/boot/efi/kernel8-pi3.img
#/boot/efi/kernel8-pi4.img

%changelog
* Tue Jul 20 2021 Filip Zaludek <filip.zaludek@oracle.com> - 2021.04-1.0.3
- efi_smbios_register(), allocate EFI_ALLOCATE_64K_ALIGN pages in lowmem then in highmem
- clean up artifacts

* Sun Jul 18 2021 Filip Zaludek <filip.zaludek@oracle.com> - 2021.04-1.0.2
- Adapted '0020-Raspberry-Pi-UEFI-Runtime-regions-are-not-aligned-to.patch' to 2021.04

* Thu Jun 3 2021 Filip Zaludek <filip.zaludek@oracle.com> - 2021.04-1.0.1
- Customized distro_bootcmd
- Enabled efidebug command
- Common u-boot rpiarm64 binary for both RPi3 and RPi4 platforms

* Wed Oct 7 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.7
- Added efi runtime align fix for kernel-uek 5.4.17-2011.6.2

* Mon Jul 6 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.6
- Add bmp cmd support.

* Sat Jun 27 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.5
- fix totol memory issue on 8G RPI4 [Orabug 31562826]

* Fri Jun 26 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.4
- fix USB device discovery issue

* Thu Jun 25 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.3
- clean up git residual

* Wed Jun 24 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.2
- port uboot env config changes
- Fix PCI probe for RPi4
- Fix USB controller for RPi4
- Enable ethernet, pci, usb on RPi4
- Fix uboot to see correct memory on OS for 8GB RPi4

* Tue Jun 23 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - 2020.07-1.0.1
- Updated uboot to latest DAS uboot repo.

* Thu Apr 16 2020 David Sloboda <david.x.sloboda@oracle.com> - 2020.01-1.0.6
- Change Release: remove character "v" (request from Filip Zaludek)

* Mon Apr 06 2020 Filip Zaludek <filip.zaludek@oracle.com> - v2020.01-1.0.5
- Add devtoolset-6 dependency for OL7.x, lukas.lipinsky@oracle.com

* Fri Apr 03 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.4
- Add missing BuildRequires [Orabug 31121792]

* Fri Jan 31 2020 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.3
- Fix fdt load address [Orabug 30838900]

* Sun Dec 15 2019 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.2
- Fix for "UEFI Runtime regions are not aligned to 64 KB". [Orabug 30665128]

* Wed Nov 06 2019 Vijay Kumar <vijay.ac.kumar@oracle.com> - v2020.01-1.0.1
- Initial build
- Ported rpi3 uboot patches
